/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace SDK.Sample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private CustomDataGrid dataGrid1;
		private System.Windows.Forms.Button cmdFillData;
		private System.Windows.Forms.Button cmdClear;
		private System.Windows.Forms.Button cmdClose;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.dataGrid1 = new CustomDataGrid();
			this.cmdFillData = new System.Windows.Forms.Button();
			this.cmdClear = new System.Windows.Forms.Button();
			this.cmdClose = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// dataGrid1
			// 
			this.dataGrid1.DataMember = "";
			this.dataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGrid1.Location = new System.Drawing.Point(24, 8);
			this.dataGrid1.Name = "dataGrid1";
			this.dataGrid1.Size = new System.Drawing.Size(624, 232);
			this.dataGrid1.TabIndex = 0;
			// 
			// cmdFillData
			// 
			this.cmdFillData.Enabled = false;
			this.cmdFillData.Location = new System.Drawing.Point(384, 264);
			this.cmdFillData.Name = "cmdFillData";
			this.cmdFillData.TabIndex = 1;
			this.cmdFillData.Text = "Fill Grid";
			this.cmdFillData.Click += new System.EventHandler(this.cmdFillData_Click);
			// 
			// cmdClear
			// 
			this.cmdClear.Location = new System.Drawing.Point(480, 264);
			this.cmdClear.Name = "cmdClear";
			this.cmdClear.TabIndex = 2;
			this.cmdClear.Text = "Clear Grid";
			this.cmdClear.Click += new System.EventHandler(this.cmdClear_Click);
			// 
			// cmdClose
			// 
			this.cmdClose.Location = new System.Drawing.Point(576, 264);
			this.cmdClose.Name = "cmdClose";
			this.cmdClose.TabIndex = 3;
			this.cmdClose.Text = "Close";
			this.cmdClose.Click += new System.EventHandler(this.cmdClose_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(680, 302);
			this.Controls.Add(this.cmdClose);
			this.Controls.Add(this.cmdClear);
			this.Controls.Add(this.cmdFillData);
			this.Controls.Add(this.dataGrid1);
			this.Name = "Form1";
			this.Text = "My Favorite Books";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void cmdClear_Click(object sender, System.EventArgs e)
		{
			this.dataGrid1.DataSource = getBlankData();
			cmdClear.Enabled = false;
			cmdFillData.Enabled = true;
		}

		private void cmdClose_Click(object sender, System.EventArgs e)
		{
		this.Close();
		}

		private void cmdFillData_Click(object sender, System.EventArgs e)
		{
			fillGridWithSampleRows();
			cmdFillData.Enabled = false;
			cmdClear.Enabled = true;
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			this.dataGrid1.DataSource = getBlankData();
			fillGridWithSampleRows();
		}

		#region Data Region

		private DataTable getBlankData()
		{
			DataTable table = new DataTable("Books");

			DataColumn idColumn = new DataColumn("Id", typeof(System.Int16));
			idColumn.AutoIncrement = true;
			idColumn.Unique = true;
            

			DataColumn titleColumn = new DataColumn("Title");
			titleColumn.AllowDBNull = false;
			DataColumn authorColumn = new DataColumn("Author");
			authorColumn.AllowDBNull = false;
			DataColumn pubColumn = new DataColumn("Publisher");

			DataColumn pubDateColumn = new DataColumn("PublishingDate", typeof(System.DateTime));
			table.Columns.Add(idColumn);
			table.Columns.Add(titleColumn);
			table.Columns.Add(authorColumn);
			table.Columns.Add(pubColumn);
			table.Columns.Add(pubDateColumn);
			return table;
		}

		private DataTable fillGridWithSampleRows()
		{
			DataTable dsTable = (DataTable) this.dataGrid1.DataSource;
            
			DataRow row = dsTable.NewRow();
			row["Title"]            = "World Is Flat";
			row["Author"]           = "Thomas L. Friedman";
			row["Publisher"]        = "Farrar, Straus & Giroux";
			row["PublishingDate"]   = new System.DateTime(1995, 05, 01);
			dsTable.Rows.Add(row);

			row = dsTable.NewRow();
			row["Title"] = "The Monk Who Sold His Ferrari";
			row["Author"] = "Robin S. Sharma";
			row["Publisher"] = "Harper Collins";
			row["PublishingDate"] = new System.DateTime(2004, 04, 19);
			dsTable.Rows.Add(row);

			row = dsTable.NewRow();
			row["Title"] = "The Story of My Experiments with Truth";
			row["Author"] = "M. K. Gandhi, Sunil Khilnani, Mahadev Desai";
			row["Publisher"] = "Penguin Books Ltd";
			row["PublishingDate"] = new System.DateTime(2001, 09, 06);
			dsTable.Rows.Add(row);

			row = dsTable.NewRow();
			row["Title"] = "You Can Win";
			row["Author"] = "Shiv Khera";
			row["Publisher"] = "New Dawn Press";
			row["PublishingDate"] = new System.DateTime(2004, 07, 01);
			dsTable.Rows.Add(row);

			row = dsTable.NewRow();
			row["Title"] = "Who Mooved My Cheese";
			row["Author"] = "Dr Spencer Johnson";
			row["Publisher"] = "Ebury Press";
			row["PublishingDate"] = new System.DateTime(1999, 03, 04);
			dsTable.Rows.Add(row);

			row = dsTable.NewRow();
			row["Title"] = "The 7 Habits of Highly Effective People";
			row["Author"] = "Stephen R. Covey";
			row["Publisher"] = "Simon & Schuster Ltd.";
			row["PublishingDate"] = new System.DateTime(1999, 01, 04);
			dsTable.Rows.Add(row);

			row = dsTable.NewRow();
			row["Title"] = "The Secret";
			row["Author"] = "Rhonda Byrne";
			row["Publisher"] = "Simon & Schuster Ltd.";
			row["PublishingDate"] = new System.DateTime(2006, 12, 04);
			dsTable.Rows.Add(row);

			return dsTable;
		}

		#endregion


		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}


       
	}
}
