/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

using System;
using System.Windows.Forms;
using Rational.Test.Ft.Domain.Win;

namespace SDK.Sample
{
	/// <summary>
	/// Summary description for AccessibilityHelper.
	/// </summary>
	public class AccessibilityHelper
	{
		public AccessibilityHelper()
		{

		}

		public static Rational.Test.Ft.Domain.Win.IWinControl GetWinParentRows(Rational.Test.Ft.Domain.Win.IWinControl winGrid)
		{
			if (winGrid == null)
				return null;

			Rational.Test.Ft.Domain.Win.IWinControl[] children = GetAccChildren(winGrid);
			if (children != null && children.Length > 0)
			{
				for (int i = 0; i < children.Length; i++)
				{
					if (children[i].AccessibleRole.Equals(".List"))
					{
						return children[i];
					}
				}
			}
			return null;
		}

		public static Rational.Test.Ft.Domain.Win.IWinControl[] GetAccChildren(Rational.Test.Ft.Domain.Win.IWinControl ctrl)
		{
			return (ctrl.AccessibleChildren);
		}

		public static  AccessibleObject GetAccessibleObjectForRow(Control myTestObject,int index)
		{
			AccessibleObject accObjGrid = myTestObject.AccessibilityObject;
			int childCount = accObjGrid.GetChildCount();
			AccessibleObject accObjChild = null;
			int rowIndex = 0;
			for (int i = 0; i < childCount; i++)
			{
				accObjChild = accObjGrid.GetChild(i);
				if (accObjChild.Role == AccessibleRole.Row)
				{
					if (rowIndex == index)
						break;
					rowIndex++;
				}
			}
			return accObjChild;
		}

		public static Rational.Test.Ft.Domain.Win.IWinControl GetWinColumnHeader(Rational.Test.Ft.Domain.Win.IWinControl winGrid, int index)
		{
			if (winGrid == null)
				return null;

			Rational.Test.Ft.Domain.Win.IWinControl[] children = GetAccChildren(winGrid);
			if (children != null && children.Length > 0)
			{
				for (int i = 0; i < children.Length; i++)
				{
					if (children[i].AccessibleRole.Equals(".Columnheader"))
					{
						if (index == 0)
							return children[i];
						index--;
					}
				}
			}

			return null;
		}




		public static Rational.Test.Ft.Domain.Win.IWinControl GetAccObj(IntPtr ctrl)
		{
			return (AccessibilityObject.GetAccessibilityObject(ctrl));
		}

	}
}
