#Region " Script Header "
' Functional Test Script
' author Administrator
Imports Microsoft.VisualBasic
Imports Rational.Test.Ft
Imports Rational.Test.Ft.Object.Interfaces
Imports Rational.Test.Ft.Object.Interfaces.SAP
Imports Rational.Test.Ft.Object.Interfaces.Siebel
Imports Rational.Test.Ft.Script
Imports Rational.Test.Ft.Value
Imports Rational.Test.Ft.Vp
#End Region

Public Class GetTreeDataExample 
    Inherits GetTreeDataExampleHelper

    'Script Name   : GetTreeDataExample
    'Generated     : Jul 17, 2006 3:25:22 PM
    'Description   : Functional Test Script
    'Original Host : Windows XP x86 5.1 build 2600 Service Pack 2 

    'since  2006/07/17
    'author Administrator

    Public Function TestMain(ByVal args() As Object)
        ' Turn off Log Viewer for this example
        SetOption(IOptionName.BRING_UP_LOGVIEWER, False)

        'Start Classics Java Application
        StartApp("ClassicsJavaA")

        ' Wait for tree to appear
        Tree2().WaitForExistence()

        ' Display available test data types available from tree
        System.Console.WriteLine(String.Format("Available Tree Data Types: {0}", Tree2().GetTestDataTypes()))

        ' Declare variables for tree
        Dim CdTree As ITestDataTree
        Dim CdTreeNodes As ITestDataTreeNodes
        Dim CdTreeNode() As ITestDataTreeNode

        ' Variables to hold tree data
        CdTree = Tree2().GetTestData("tree")
        CdTreeNodes = CdTree.GetTreeNodes()
        CdTreeNode = CdTreeNodes.GetRootNodes()


        ' Print out total number of nodes
        System.Console.WriteLine("Tree Total Node Count: " + CdTreeNodes.GetNodeCount().ToString())
        System.Console.WriteLine("Tree Root Node Count : " + CdTreeNodes.GetRootNodeCount().ToString())

        ' Iterate through tree branches; this is a recursive method.

        Dim I As Integer

        For I = 0 To CdTreeNode.Length - 1
            ShowTree(CdTreeNode(I), 0)
        Next I

        ' Shut down Classics Java Application
        ClassicsJava(ANY, MAY_EXIT).Close()
    End Function

    Public Sub ShowTree(ByVal Node As ITestDataTreeNode, ByVal _
        Indent As Integer)
        ' Recursive method to print out tree nodes with proper
        ' indenting.

        ' Determine number of tabs to use - to properly indent tree
        Dim TabCount As Integer
        IIf(Indent < Tabs.Length(), TabCount = Indent, TabCount = Tabs.Length())

        ' Print out node name + number of children
        System.Console.WriteLine(Tabs.Substring(0, TabCount) + Node.GetNode().ToString() + " (" + Node.GetChildCount().ToString() + " Children)")

        ' Determine if node has children; recursively call this same
        ' method to print out child nodes.
        Dim Children() As ITestDataTreeNode = Node.GetChildren()
        Dim ChildCount As Integer

        IIf(ChildCount <> 0, ChildCount = Children.Length, ChildCount = 0)

        Dim I As Integer

        For I = 0 To ChildCount - 1
            ShowTree(Children(I), Indent + 1)
        Next I
    End Sub

    ' String of tabs used to indent tree view
    Const Tabs As String = _
    "\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t"

End Class


